_user_int_ram  .equ  $D2FD

.org $D748		;_asm_exec_ram

 call $4AB1			;_runindicoff
 call $49DC			;_flushallmenus
 call $4A82			;_clrScrn
;decompress or copy the picture data for each picture (5 total) to the correct location
 ld de,oni_1
 call decompV
 ld hl,$FC00
 ld de,$CA00
 ld bc,1024
 ldir
 ld de,oni_2
 call decompV
 ld hl,$FC00
 ld de,$F600
 ld bc,1024
 ldir
 ld de,oni_3
 call decompV
 ld hl,$FC00
 ld de,$F200
 ld bc,1024
 ldir
 ld de,oni_4
 call decompV
 ld hl,$FC00
 ld de,$EE00
 ld bc,1024
 ldir
 ld de,oni_5
 call decompV

 res 2,(iy+$23)		;turn user int off so it won't get called by
					;accident before we're ready
clear_int:		;I always clear the interrupt for neatness (mainly for debugging)
 ld hl,$d2fd	;point hl to interrupt RAM
 ld (hl),$5A	;$5A is the standard checksum for a blank interrupt
 inc hl			;point hl one byte forward
 ld (hl),0		;clear the next byte
 ld de,$d2ff	;point de to the byte after hl
 ld bc,198		;we have to clear 198 bytes (of 200) since we already did the 1st & 2nd
 ldir			;clear it out

 ld hl,int				;hl point to the begining of the program
 ld de,_user_int_ram+1	;de pionts to where the program is to be loaded
 ld bc,int_end-int		;bc is the length of the program to be sent
 ldir					;copies it

 ld a,(_user_int_ram+1)			;this sets up checksum byte - 
 ld hl,_user_int_ram+($28*1)	;we need to add the 1st bite with another one
 add a,(hl)						;every 40 bytes and store it in the...
 ld hl,_user_int_ram+($28*2)
 add a,(hl)
 ld hl,_user_int_ram+($28*3)
 add a,(hl)
 ld hl,_user_int_ram+($28*4)
 add a,(hl)
 ld hl,_user_int_ram+($28*5)
 add a,(hl)
 ld (_user_int_ram),a			;first byte of the interrupt area

 set 2,(iy+$23)				;turn on the interrupt
 ld b,10
keyLoop:
 halt
 djnz keyLoop
 ld b,10

 ld a,%10000000
 out (1),a
 in a,(1)
 cp $FF
 jr z,keyLoop

 res 2,(iy+$23)		;turn user int off
 ld a,$3C
 out (0),a
 call $4A82			;_clrScrn
 ret


int:
 push af
 push hl
 ld hl,counter
 dec (hl)
 jr nz,EndIntRoutine
 ld (hl),2
 inc hl
 ld hl,page_number
 ld a,(hl)
 cp 32				;where to put the "use #"
 jr nz,keepgoing
 ld (hl),1
keepgoing:
 ld b,(hl)
 inc (hl)
findpage:
 inc hl
 djnz findpage
 ld a,(Last)
 cp (hl)
 jr z,EndIntRoutine
 ld a,(hl)
 out (0),a
 ld (Last),a
EndIntRoutine:
 pop hl
 pop af
 ret
int_end:


Last:
	.db 0
counter:
	.db 2

page_number:
	.db 1
page_order:
;gray 32 (use 32 & all pics)
	.db $2E,$3C,$3C,$32,$2E,$3C,$3C,$36,$2E,$3C,$3C,$32
	.db $2E,$3C,$0A,$3C,$3C,$2E,$32,$3C,$2E,$3C,$3C,$2E
	.db $36,$3C,$3C,$32,$2E,$3C,$3C

;gray 16 (use 14 & last 4 pics only)
;	.db $3C,$2E,$3C,$32,$3C,$36,$3C,$2E,$3C,$32,$3C,$2E,$3C

;gray 8 (use 8 & last 3 pics only)
;	.db $3C,$2E,$3C,$32,$3C,$2E,$3C

;gray 4 (use 5 & last 2 pics only)
;	.db $3C,$2E,$3C,$2E,$3C



;********************************************************
; -decompresses data that is vertically compressed with
; bmp2asm, by Levi Lansing    (total size=63 bytes)
; -(decompresses data into the video memory - 1024 bytes)
; -de=location of data to decompress
; -destroys- a,b,c,hl,de (points to byte after data)
;********************************************************
decompV:
 ld hl,$FC00        ;point hl to the screen mem
decompLoop:
 ld a,(de)          ;load the first byte of the compressed data
 cp $B7             ;check if it's a marker
 jr nz,DCnorm       ;if it's not, treat it as a normal byte
 inc de             ;if the byte is marked, the next byte tells us the value
 ld a,(de)          ;that is repeated so we
 ld c,a             ;put that in c
 inc de             ;the next byte tells us how many times it's repeated
 ld a,(de)
 ld b,a             ;we will load that into b to be used as a counter
 inc de             ;point to the next byte for later
DCrepeatLoop:
 ld (hl),c          ;put the value in the screen mem once
 push de            ;hide de
 ld de,16
 add hl,de          ;point hl to the next row (16 bytes forward)
 jr nc,DCloop       ;if hl isn't past the end of the screen data ($FFFF), then continue
 ld de,1022         ;if it is, we need to put it back to the next column
 sbc hl,de          ;point hl to the 1st row of the next column
 ld a, l
 cp $10             ;if l is over $10 (16d), it has completed the full screen
 jr c,DCloop        ;jump if it's not over $10 to continue
 pop de             ;restore de again
 ret                ;return from the routine
DCloop:
 pop de             ;restore de
 djnz DCrepeatLoop  ;decrement b and continue loading the same byte down the
                    ;column until b is 0
 jr decompLoop      ;continue with the next byte
DCnorm:
 ld (hl),a          ;load the byte into the screen mem
 inc de             ;point de to the next byte
 push de            ;hide it
 ld de, 16
 add hl,de          ;point hl to the next row (16 bytes forward)
 pop de             ;restore de
 jr nc,decompLoop   ;if hl did not go past $FFFF (it would flip to 0+) then continue
 push de            ;hide de again
 ld de, 1022
 sbc hl,de          ;subtracting 1022 from hl put's it at the 1st row of the next column
 ld a, l
 cp $10             ;check if hl is past the first row (if it is, we finished decompressing)
 pop de             ;restore de again
 jr c,decompLoop    ;if we're not done, keep going...
 ret                ;if we get here, we're done and will return from the routine



oni_1:
;Compressed picture made with BMP2ASM v1.1 by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 274 bytes - 73% compressed!
  .db $B7, $FF, $FF, $B7, $FF, $3A, $FE, $FE, $FF, $F7, $B7, $FF, $17, $FC, $F0, $F1
  .db $B7, $FF, $0C, $F8, $FC, $B7, $FF, $0D, $FC, $FC, $F8, $F0, $C1, $AB, $9F, $1F
  .db $7F, $B7, $FF, $0C, $FE, $FC, $FE, $FE, $FC, $F8, $F0, $F0, $F0, $E0, $F0, $C1
  .db $01, $01, $00, $41, $C3, $C1, $C3, $E2, $C0, $C1, $C3, $C1, $C7, $84, $E0, $00
  .db $03, $11, $79, $F0, $F0, $F0, $E1, $E3, $E4, $C5, $85, $83, $83, $07, $2F, $3F
  .db $3F, $3F, $7F, $B7, $FF, $0B, $F0, $E0, $E0, $C0, $B7, $00, $08, $03, $0B, $0F
  .db $3E, $20, $40, $1D, $3F, $FF, $F8, $EC, $E0, $A8, $F4, $A4, $5C, $BC, $B8, $E0
  .db $81, $0B, $3D, $E3, $C3, $C3, $CF, $8F, $DF, $B7, $B7, $01, $C6, $84, $1C, $18
  .db $8C, $8C, $8E, $0E, $07, $01, $C0, $80, $00, $A0, $C0, $80, $C0, $E8, $F0, $FE
  .db $FF, $FF, $FF, $7F, $FF, $7F, $7F, $3F, $3F, $1F, $1F, $1F, $3F, $FF, $FF, $FF
  .db $BF, $0F, $80, $00, $00, $60, $F0, $F0, $30, $10, $30, $10, $20, $41, $41, $01
  .db $01, $03, $C3, $F3, $E7, $E3, $CE, $CC, $DC, $FE, $3C, $3C, $38, $30, $00, $01
  .db $01, $02, $1B, $CF, $FF, $FF, $7C, $0E, $40, $B7, $00, $06, $03, $B7, $FF, $12
  .db $7F, $B7, $3F, $06, $7F, $7F, $7F, $B7, $FF, $06, $F7, $FF, $FF, $5F, $0F, $03
  .db $01, $B7, $00, $05, $A2, $F3, $73, $FF, $FF, $FE, $FC, $F0, $B7, $00, $06, $0D
  .db $0F, $BF, $B7, $FF, $2B, $DF, $5F, $EF, $F7, $E3, $C3, $C1, $C0, $80, $B7, $00
  .db $04, $06, $07, $17, $1F, $3F, $B7, $FF, $35, $B7, $7F, $04, $B7, $FF, $FF, $B7
  .db $FF, $0F

oni_2:
;Compressed picture made with BMP2ASM v1.1 by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 237 bytes - 77% compressed!
  .db $B7, $FF, $FF, $B7, $FF, $3B, $FD, $F9, $F3, $CF, $B7, $FF, $18, $EE, $EF, $B7
  .db $FF, $0A, $FE, $FF, $FF, $FE, $B7, $FF, $0B, $FE, $B7, $FF, $05, $D7, $6F, $B7
  .db $FF, $0F, $FD, $B7, $FF, $07, $DF, $AF, $FF, $FF, $FE, $FF, $FE, $FD, $FF, $FD
  .db $DD, $FF, $FE, $FD, $FE, $F8, $FB, $DF, $FF, $FD, $FF, $B7, $B7, $01, $FF, $FF
  .db $EF, $FE, $DF, $DB, $DB, $F9, $FF, $7F, $FF, $DF, $DF, $DF, $B7, $FF, $19, $FD
  .db $F7, $F7, $EF, $DF, $BF, $EB, $DD, $7F, $FF, $F3, $DF, $F7, $FF, $FF, $AF, $5F
  .db $7B, $6F, $7E, $F5, $F3, $FF, $F7, $FF, $FF, $FF, $A7, $CF, $BF, $7F, $E3, $EF
  .db $FB, $B7, $FF, $04, $7F, $BF, $7F, $FF, $DF, $BF, $BF, $FF, $D7, $FF, $FD, $B7
  .db $FF, $04, $7F, $B7, $FF, $06, $DF, $FF, $7F, $FF, $FF, $FF, $F7, $7F, $B7, $FF
  .db $05, $DF, $FF, $DF, $FF, $FF, $FF, $BF, $B7, $FF, $04, $EB, $FF, $FF, $FD, $FF
  .db $AF, $9F, $B7, $FF, $05, $FE, $FF, $FF, $E7, $BF, $FF, $FF, $BB, $F7, $BF, $B7
  .db $FF, $06, $FB, $B7, $FF, $14, $DF, $B7, $FF, $06, $7F, $B7, $FF, $08, $DF, $BF
  .db $F7, $B7, $FF, $07, $7C, $EF, $6F, $F7, $B7, $FF, $0A, $F7, $F3, $5F, $B7, $FF
  .db $2A, $DF, $FF, $EF, $FF, $FF, $FF, $FD, $FF, $BF, $7F, $B7, $FF, $04, $FB, $FF
  .db $FF, $FF, $BF, $B7, $FF, $39, $7F, $B7, $FF, $FF, $B7, $FF, $0E

oni_3:
;Compressed picture made with BMP2ASM v1.1 by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 113 bytes - 89% compressed!
  .db $B7, $FF, $FF, $B7, $FF, $3D, $F7, $B7, $FF, $4D, $FD, $B7, $FF, $05, $EF, $B7
  .db $FF, $05, $BE, $B7, $FF, $09, $BD, $B7, $FF, $04, $3F, $B7, $FF, $0D, $DF, $B7
  .db $FF, $0F, $DF, $B7, $FF, $0C, $EE, $B7, $FF, $08, $DF, $B7, $FF, $05, $EF, $FF
  .db $FF, $F7, $FF, $F7, $B7, $FF, $0E, $7F, $B7, $FF, $25, $EF, $FF, $FF, $FF, $FD
  .db $FF, $FF, $FF, $FB, $FF, $DF, $FB, $B7, $FF, $0A, $FD, $FF, $F7, $B7, $FF, $0B
  .db $FB, $B7, $FF, $15, $7F, $B7, $FF, $0E, $DF, $B7, $FF, $0B, $77, $B7, $FF, $3B
  .db $7F, $B7, $FF, $0B, $FD, $FF, $EF, $B7, $FF, $36, $7F, $B7, $FF, $FF, $B7, $FF
  .db $12

oni_4:
;Compressed picture made with BMP2ASM v1.1 by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 273 bytes - 73% compressed!
  .db $B7, $FF, $FF, $B7, $FF, $3A, $FE, $FC, $FD, $FB, $C7, $B7, $FF, $16, $F8, $F0
  .db $E0, $EF, $B7, $FF, $0A, $FE, $FC, $FC, $FE, $B7, $FF, $0B, $FE, $FC, $FC, $F8
  .db $F0, $C1, $8B, $0F, $1F, $7F, $B7, $FF, $0B, $B7, $FE, $05, $FC, $F8, $F0, $F0
  .db $F0, $D0, $A0, $C1, $01, $00, $00, $C1, $C1, $C1, $C3, $C1, $B7, $C0, $05, $C2
  .db $C0, $00, $03, $11, $D1, $F0, $F0, $E0, $E0, $C3, $C3, $E1, $83, $83, $07, $07
  .db $0F, $1F, $3F, $3F, $BF, $B7, $FF, $0B, $F0, $E0, $E0, $C0, $B7, $00, $07, $01
  .db $01, $03, $07, $3F, $40, $00, $0D, $1D, $7F, $F8, $E0, $C0, $A0, $D4, $EC, $CC
  .db $18, $38, $70, $01, $01, $29, $E1, $CB, $C3, $8F, $8F, $87, $87, $86, $04, $00
  .db $88, $88, $8C, $8E, $07, $07, $85, $81, $00, $00, $80, $80, $C0, $C0, $E0, $F0
  .db $FE, $B7, $FF, $04, $7F, $7F, $7F, $3F, $3F, $1F, $1F, $1F, $3F, $7F, $FF, $FF
  .db $9F, $07, $00, $00, $00, $60, $F0, $F0, $10, $10, $10, $30, $20, $41, $01, $03
  .db $01, $03, $C3, $E7, $E7, $E3, $C4, $CC, $9C, $9C, $1C, $3C, $38, $30, $00, $00
  .db $01, $02, $13, $8F, $FF, $FF, $3C, $06, $B7, $00, $07, $07, $B7, $FF, $12, $7F
  .db $3F, $1F, $9F, $3F, $3F, $3F, $7F, $7F, $7F, $B7, $FF, $09, $1F, $07, $03, $01
  .db $B7, $00, $05, $21, $E3, $EB, $FF, $FF, $FE, $FC, $F8, $B7, $00, $06, $05, $03
  .db $1F, $B7, $FF, $2A, $DF, $DF, $CF, $CF, $F7, $E3, $C3, $C1, $80, $B7, $00, $05
  .db $03, $07, $17, $1F, $7F, $B7, $FF, $36, $B7, $7F, $04, $B7, $FF, $FF, $B7, $FF
  .db $0E

oni_5:
;Compressed picture made with BMP2ASM v1.1 by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 15 bytes - 99% compressed!
  .db $B7, $FF, $FF, $B7, $FF, $FF, $B7, $FF, $FF, $B7, $FF, $FF, $B7, $FF, $05
.end
